hector-fleet-management-system-master/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


// Resources
Route::resource('vehicles', 'VehicleController');
Route::resource('departments', 'DepartmentController');
Route::resource('vehicle_models', 'VehicleModelController');
Route::resource('orders', 'OrderController');
Route::resource('order_requests', 'OrderRequestController');


Route::get('/home', 'HomeController@index')->name('home');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

hector-fleet-management-system-master/app/Vehicle_model.php
<?php

namespace App;
use Illuminate\Support\Arr;

use Illuminate\Database\Eloquent\Model;

class Vehicle_model extends Model
{
    public function vehicles() {
        return $this->hasMany(Vehicle::class);
    }

    public function vehicle_category() {
        return $this->belongsTo(Vehicle_category::class);
    }
}

hector-fleet-management-system-master/app/Http/Controllers/VehicleModelController.php
<?php

namespace App\Http\Controllers;

use App\Vehicle_model;
use App\Vehicle;
use App\Vehicle_category;

use Session;
use Illuminate\Support\Facades\Auth;


use Illuminate\Http\Request;
use Illuminate\Support\Arr;

class VehicleModelController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
public function index()
    {

        if(Session::has('order_request')) {
            // Get model ids from request
            $request_model_ids = array_keys(Session::get('order_request'));
            
            // Query
            $request_models = Vehicle_model::find($request_model_ids);
            
            // Set quantities
            foreach($request_models as $request_model) {
                $request_model->quantity = Session::get("order_request.$request_model->id");
            }
            // return dd($request_models);

            // Return to index with updated request
            return view('vehicle_models.index')
                ->with('vehicle_models', Vehicle_model::orderBy('make')->paginate(12))
                ->with('request_models', $request_models);
        } else {
            // Return to models index
            return view('vehicle_models.index')->with('vehicle_models', Vehicle_model::orderBy('make')->paginate(12));
        }

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('vehicle_models.create')->with('categories', Vehicle_category::all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Vehicle_model $vehicle_model)
    {
        
        $request->validate([
            'name' => 'required',
            'make' => 'required',
            'category' => 'required',
            'year' => 'digits:4',
            'image' => 'image|max:5000',
            'description' => 'required',
            'seats' => 'required|min:1'
            ]);
            
        if(Vehicle_model::where([
            ['make', "=", $request->input('make')],
            ['name', '=', $request->input('name')],
            ['year', '=', $request->input('year')]
        ])->first()) {
            return back()->withErrors('Vehicle model is already existing')->withInput();
        };

        $vehicle_model = new Vehicle_model;
        $vehicle_model->name = ucwords($request->input('name'));
        $vehicle_model->make = ucwords($request->input('make'));
        $vehicle_model->year = $request->input('year');
        $vehicle_model->description = $request->input('description');
        $vehicle_model->seats = $request->input('seats');
        $vehicle_model->vehicle_category_id = $request->input('category');
        $vehicle_model->save();        

        if($request->hasFile('image')) {
            $filename = 'model_' . $vehicle_model->id . "." . $request->image->extension();
            // $vehicle_model->image = $request->image->storeAs('model_images', $filename, 'public');
            $vehicle_model->image = $request->image->storeAs('model-images', $filename, 'public');
    
            $vehicle_model->save();
        }

        $request->session()->flash('success', 'Vehicle successfully added');

        return redirect(route('vehicle_models.show', ['vehicle_model' => $vehicle_model->id]));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Vehicle_model  $vehicle_model
     * @return \Illuminate\Http\Response
     */
    public function show(Vehicle_model $vehicle_model)
    {
        $vehicles = Arr::sort(Vehicle::all()->where('vehicle_model_id', $vehicle_model->id), function ($value) {
            return $value->vehicle_status_id;
        });
        return view('vehicle_models.show')->with('vehicle_model', $vehicle_model)->with('vehicles', $vehicles);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Vehicle_model  $vehicle_model
     * @return \Illuminate\Http\Response
     */
    public function edit(Vehicle_model $vehicle_model)
    {
        return view('vehicle_models.edit')->with('vehicle_model', $vehicle_model)->with('vehicle_categories', Vehicle_category::all());
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Vehicle_model  $vehicle_model
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Vehicle_model $vehicle_model)
    {
        if($vehicle_model->name !== $request->input('name') && $vehicle_model->make !== $request->input('make') && $vehicle_model->year !== $request->input('year')) {
            $request->validate([
                'name' => 'required',
                'make' => 'required',
                'category' => 'required',
                'year' => 'digits:4',
                'description' => 'required',
                'seats' => 'required|min:1'
                ]);
                
            if(Vehicle_model::where([
                ['make', "=", $request->input('make')],
                ['name', '=', $request->input('name')],
                ['year', '=', $request->input('year')]
            ])->first()) {
                return back()->withErrors('Vehicle model is already existing')->withInput();
            };
        } else {
            $request->validate([
                'name' => 'required',
                'make' => 'required',
                'category' => 'required',
                'year' => 'digits:4',
                'description' => 'required',
                'seats' => 'required|min:1'
                ]);
        }

        $vehicle_model->name = $request->input('name');
        $vehicle_model->make = $request->input('make');
        $vehicle_model->year = $request->input('year');
        $vehicle_model->vehicle_category_id = $request->input('category');
        $vehicle_model->description = $request->input('description');
        $vehicle_model->seats = $request->input('seats');

        if($request->has('image')) {
            $request-> validate([
                'image' => 'image|max:5000',
            ]);

            $vehicle_model->image = $request->image->storeAs('/', $vehicle_model->image, 'public');
        }

        $vehicle_model->save();

        return redirect(route('vehicle_models.edit', ['vehicle_model' => $vehicle_model->id]));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Vehicle_model  $vehicle_model
     * @return \Illuminate\Http\Response
     */
    public function destroy(Vehicle_model $vehicle_model, Request $request)
    {
        if(!Vehicle::where('vehicle_model_id', $vehicle_model->id)->first()) {
            $vehicle_model->delete();
            $request->session()->flash('success', 'Vehicle model deleted successfully');
        } else {
            $request->session()->flash('fail', 'Unable to remove vehicle model. There are existing vehicles with that model');
        }
        
        return redirect(route('vehicle_models.index'));
    }
}

hector-fleet-management-system-master/resources/views/vehicle_models/create.blade.php
@extends('layouts/app')

@section('title', 'Add a Vehicle Model')

@section('content')


<div class="row mt-4">
    
    {{-- Start of Messages --}}
    @include('messages')
    {{-- End of Messages --}}

    <div class="col-12 text-center">
        <h1>Add New Model</h1>
    </div>

    <div class="col-12 col-md-8 col-lg-6 mx-auto mt-5">
        
        <form action="{{route('vehicle_models.store')}}" method="post" enctype="multipart/form-data">
            @csrf
            
            <div class="form-group">
                <label for="name">Model Name:</label>
                <input type="text" name="name" class="form-control" value="{{old('name')}}" required placeholder="Model Name">
            </div>

            <div class="form-group">
                <label for="make">Make:</label>
                <input type="text" name="make" class="form-control" value="{{old('make')}}" required placeholder="Model Make">
            </div>

            <div class="row">
                <div class="form-group col-6">
                    <label for="year">Year:</label>
                    <input type="number" name="year" class="form-control" value="{{old('year')}}" required placeholder="{{date('Y')}}">
                </div>
                
                <div class="form-group col-6">
                    <label for="year">Number of Seats:</label>
                    <input type="number" name="seats" class="form-control" value="{{old('seats')}}" required placeholder="Number of Seats">
                </div>
            </div>

            <div class="form-group mb-3">
                <label for="category">Category:</label>
                <select name="category" class="form-control mb-2" required>
                    <option value="" selected>Choose a category</option>
                    {{-- Start of Model List --}}
                    @foreach($categories as $category)
                    <option value="{{$category->id}}"
                        {{old('category') == $category->id ? "selected" : ""}}
                        >
                        {{"$category->name"}}
                    </option>
                    @endforeach
                    {{-- End of Model List --}}

                </select>
            </div>

            <div class="form-group">
                <label for="image">Image:</label>
                <input type="file" name="image" id="image" class="form-control-file">
            </div>

            <div class="form-group mb-5">
                <label for="description">Description:</label>
                <textarea name="description" rows="10" class="form-control" placeholder="Description">{{old('description')}}</textarea>
            </div>

            <button class="btn btn-primary w-100 mb-3" type="submit">Submit New Vehicle Model</button>

        </form>

        <a href="{{route('vehicle_models.index')}}" class="btn btn-secondary w-100">Cancel</a>

    </div>
</div>


@endsection

hector-fleet-management-system-master/resources/views/vehicle_models/edit.blade.php
@extends('layouts/app')

@section('title', "Update Vehicle Model")

@section('content')


<div class="row mt-4">
    
    {{-- Start of Messages --}}
    @include('messages')
    {{-- End of Messages --}}
    
    <div class="col-12 col-md-8 col-lg-6 mx-auto">
        
        <div class="row">
            <div class="col-6 text-left mb-5">
                <h2 class="mb-1">Update {{"$vehicle_model->make $vehicle_model->name $vehicle_model->year"}}</h2>
            </div>
            <div class="col-6 text-left mb-5 text-right">
                <a href="{{route('vehicle_models.index')}}" class="btn btn-secondary px-5">Back</a>
            </div>
        </div>

        <img src="/public/{{$vehicle_model->image}}" alt="" class="img-fluid">
        

        <form action="{{route('vehicle_models.update', ['vehicle_model' => $vehicle_model->id])}}" method="post" enctype="multipart/form-data">
            @method('put')
            @csrf
            
            <div class="form-group">
                <label for="name">Model Name:</label>
                <input type="text" name="name" class="form-control" value="{{$vehicle_model->name}}" required placeholder="Model Name">
            </div>

            <div class="form-group">
                <label for="make">Make:</label>
                <input type="text" name="make" class="form-control" value="{{$vehicle_model->make}}" required placeholder="Model Make">
            </div>

            <div class="row">
                <div class="form-group col-6">
                    <label for="year">Year:</label>
                    <input type="number" name="year" class="form-control" value="{{$vehicle_model->year}}" required placeholder="{{date('Y')}}">
                </div>
                
                <div class="form-group col-6">
                    <label for="year">Number of Seats:</label>
                    <input type="number" name="seats" class="form-control" value="{{$vehicle_model->seats}}" required placeholder="Number of Seats">
                </div>
            </div>

            <div class="form-group mb-3">
                <label for="category">Category:</label>
                <select name="category" class="form-control mb-2" required>
                    <option value="" selected>Choose a category</option>
                    {{-- Start of Model List --}}
                    @foreach($vehicle_categories as $category)
                    <option value="{{$category->id}}"
                        @if(old('category'))
                            {{old('category') == $category->id ? "selected" : ""}}
                            >
                            {{"$category->name"}}
                        @else
                            {{$vehicle_model->vehicle_category_id == $category->id ? "selected" : ""}}
                            >
                            {{"$category->name"}}
                        @endif

                    </option>
                    @endforeach
                    {{-- End of Model List --}}

                </select>
            </div>

            <div class="form-group">
                <label for="image">Image:</label>
                <input type="file" name="image" id="image" class="form-control-file">
            </div>

            <div class="form-group mb-5">
                <label for="description">Description:</label>
                <textarea name="description" rows="10" class="form-control" placeholder="Description">{{$vehicle_model->description}}</textarea>
            </div>

            <button class="btn btn-primary w-100 mb-3" type="submit">Submit New Vehicle Model</button>

        </form>

        <a href="{{route('vehicle_models.index')}}" class="btn btn-secondary w-100">Cancel</a>


    </div>
</div>


@endsection

hector-fleet-management-system-master/resources/views/vehicle_models/index.blade.php
@extends('layouts/app')
{{-- {{dd($vehicle_models)}} --}}

@section('title', 'Vehicles')

@section('content')

<div class="row mt-4 mb-0">

    
{{-- Start of Messages --}}
@include('messages')
{{-- End of Messages --}}

</div>

<div class="row">

   {{-- START MAIN --}}
    <div class="
    @if(Auth::user() !== null && Auth::user()->can('isMod'))
        col-sm-12
    @else
        col-lg-9
    @endif
    ">
        
        <div class="row">
            <div class="col-6">
                <h1>{{ Auth::user()->can('isUser')? "Choose Vehicles" : "Vehicle Models" }}</h1>
            </div>

            @can('isMod')
            <div class="col-6 text-right">
                <a href="{{route('vehicle_models.create')}}" class="btn btn-secondary ml-1 mb-2">&plus; Add a Vehicle Model</a>
            </div>
            @endcan


        </div>

        <div class="row pr-lg-2">
            
            {{-- Start of Vehicle Cards --}}
            @foreach($vehicle_models as $vehicle_model)
                @include('vehicle_models.inc.model_card')
            @endforeach
            {{-- End of Vehicle Cards --}}

        </div>
    </div>
    {{-- END MAIN --}}

        {{-- START CART --}}
        @can('isUser')
        <div class="col-sm-3 accordion d-none d-lg-block request-form" id="model-accordion">
            <div class="card">
                <div class="card-header p-0 bg-primary" id="model-list-toggle">
                    <button class="btn btn-primary w-100" data-toggle="collapse" data-target="#model-list">Vehicle Requests</button>
                </div>
                <div class="card-body collapse show" id="model-list" data-parent="#model-accordion">

                    {{-- Start Vehicle Items --}}
                    @if(Session::has('order_request'))
                    @foreach($request_models as $request_model)
                        <div class="row">
                            <div class="col-12">
                                {{-- DELETE Cart Item --}}
                                <form action="{{route('order_requests.destroy', ['order_request' => $request_model->id])}}" class="float-right" method="post">
                                    @csrf
                                    @method('delete')
                                    <button class="btn text-danger p-0" data-toggle="tooltip" title="Remove vehicle from request">
                                        <i class="far fa-times-circle"></i>
                                    </button>
                                </form>
                            </div>
                            <div class="col-12">
                                <div class="row mb-2">
                                    <div class="col-4">
                                        <img src="/public/{{$request_model->image}}" alt="" class="img-fluid">
                                    </div>
                                    <div class="col-8">
                                        <div class="row">
                                            <p class="mb-0">{{ "$request_model->make $request_model->name" }}</p>
                                        </div>
                                        <div class="row">
                                            <small>{{$request_model->year}}</small>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-12">
                                <form action="{{route('order_requests.update', ['order_request' => $request_model->id])}}" method="post">
                                    @csrf
                                    @method('put')
                                    <label for="quantity" class="mb-1">Quantity:</label>
                                    <div class="form-group flex-fill row mb-0">
                                        <div class="col-12 input-group">
                                            <input type="number" class="form-control p-1 text-center" name="quantity" value="{{$request_model->quantity}}">
                                            <div class="input-group-append">
                                                <button class="btn btn-primary btn-sm w-100 h-100">Update</button>
                                            </div>
                                        </div>
                                        <div class="col-8 pl-0">
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                        <hr>
                    @endforeach

                    
                    @else
                    <span class="text-center d-block">Your request list is empty</span>
                    @endif
                    {{-- End Vehicle Items --}}
                </div>
                
                <div class="card-header bg-primary p-0" id="formAccordion">
                    <button class="btn btn-primary w-100" type="button" data-toggle="collapse" data-target="#formCollapse" aria-expanded="true" aria-controls="formCollapse">
                    <i class="fas fa-chevron-down"></i> Next
                    </button>
                </div>
                
                {{-- REQUEST FORM --}}
                <div class="card-body py-4 collapse" id="formCollapse" aria-labelledby="headingOne" data-parent="#model-accordion">
                    <form class="mb-3" action="{{ route('orders.store') }}" method="post">
                        @csrf
                        <div class="form-group">
                            <label for="borrow_date" class="mb-0">Borrow Date:</label>
                            <input type="date" name="borrow_date" class="form-control" value="{{ old('borrow_date')? old('borrow_date') : date('Y-m-d') }}">
                        </div>
                        <div class="form-group">
                            <label for="return_date" class="mb-0">Return Date:</label>
                            <input type="date" name="return_date" class="form-control" value="{{ old('return_date')? old('borrow_date') : date('Y-m-d') }}">
                        </div>
                        <div class="form-group">
                            <label for="purpose" class="mb-0">Purpose:</label>
                            <textarea name="purpose" id="purpose" rows="5" class="form-control">{{ old('purpose') }}</textarea>
                        </div>
                        <button class="btn btn-secondary w-100" type="submit">Submit Request</button>
                    </form>
                    <form action="#">
                        <button class="btn btn-danger w-100" type="submit">Cancel Request</button>
                    </form>
                </div>
                <div class="card-footer bg-primary p-3">
                </div>
            </div>
            
        </div>
        @endcan
        {{-- END CART --}}

</div>

<div class="row section px-3">
    
    
</div>
<div class="row mt-4">
    <div class="mx-auto">
        {{$vehicle_models->links()}}
    </div>
</div>

@endsection

hector-fleet-management-system-master/resources/views/vehicle_models/show.blade.php
@extends('layouts/app')
{{-- {{dd($vehicle_models)}} --}}

@section('title', 'Vehicles')

@section('content')

<div class="row my-4">
    
    {{-- Start of Messages --}}
    @include('messages')
    {{-- End of Messages --}}

    
</div>

<div class="card">   
    <div class="card-header order">
        <div class="row px-3">
            <a href="{{route('vehicle_models.index')}}" class="btn btn-primary mr-3">Back</a>
            <h2 class="m-0 d-inline">Vehicle Model</h2>
        </div>
    </div> 
    <div class="card-body bordered p-5">
        <div class="row">
            <div class="col-lg-6">
                <img src="/public/{{$vehicle_model->image}}" alt="{{"$vehicle_model->make $vehicle_model->name $vehicle_model->year"}}" class="img-fluid">
            </div>
        
            <div class="col-lg-6">
                <h3>{{"$vehicle_model->make $vehicle_model->name $vehicle_model->year"}}</h3>
                <p class="mb-5">{{$vehicle_model->vehicle_category->name}} | Seats: {{$vehicle_model->seats}}</p>
                <p class="mb-5">{{$vehicle_model->description}}</p>
                
                @can('isMod')
                <div class="col-12 text-right">
                    <a href="{{route('vehicle_models.edit', ['vehicle_model' => $vehicle_model->id])}}" class="btn btn-primary text-light">Update Vehicle Model</a>
                    <form action="{{route('vehicle_models.destroy', ['vehicle_model' => $vehicle_model->id])}}" method="post" class="d-inline">
                        @csrf
                        @method('delete')
                        <button class="btn btn-danger w-lg-25" type="submit">Delete Vehicle Model</button>
                    </form>
                </div>
                @endcan
            </div>
        </div>
    </div>
    <div class="card-body order">

    </div>
</div>

{{-- Start Vehicle List --}}
@can('isMod')
<div class="row mt-3 border p-5 d-none d-lg-block">
    <div class="col-12">
        <h3 class="mb-4">Vehicle List</h3>
    </div>

    <div class="col-12">
        <table class="table table-sm table-hover text-center">
            <thead>
                <tr>
                    <th>Plate Number</th>
                    <th>Status</th>
                    <th>Vehicle Details</th>
                </tr>
            </thead>

            <tbody>
                {{-- Start of Vehicle Info --}}
                @foreach($vehicles as $vehicle)
                <tr>
                    <td  class="align-middle">{{$vehicle->plate_number}}</td>
                    <td class="text-light font-weight-bold">
                        <div class=" p-2
                            @switch($vehicle->vehicle_status_id)
                                @case(1)
                                    bg-success
                                    @break
                                @case(2)
                                    bg-danger
                                    @break
                                @case(3)
                                    bg-secondary
                                    @break
                            @endswitch
                        ">
                        {{strtoupper($vehicle->vehicle_status->name)}}
                        </div>
                    </td>
                    <td class="align-middle">
                        <a href="{{route('vehicles.show', ['vehicle' => $vehicle->id])}}" class="btn btn-sm btn-outline-primary">View Vehicle Details</a>
                    </td>
                </tr>
                @endforeach
                {{-- End of Vehicle Info --}}
            </tbody>
        </table>
    </div>
</div>
@endcan
{{-- End Vehicle List --}}

@endsection